/***
* BSFFT1D is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
* 
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program.  If not, see <http://www.gnu.org/licenses/>.
* 
* $LastChangedDate: 2016-05-20 13:54:36 +0200 (Fr, 20. Mai 2016) $
* $Author: melzer $
* $Revision: 6398 $
*
*/





#include "tree1D.h"
#include "sparseDFT1D.h"
#include "sparseFFT1D.h"
#include "sparseFFT1D_mtimes.h"
#include <ctime>

int main(){

		int L=12;
		unsigned int N;
		N=pow(2,L); //bandwidth
		int p=7; //approximation rank


		//init Matrix of points and index vector
		vec MX(N),MOmega(N);
		vector <unsigned int> indices;

		//random vectors in [0,N]^N
		MX=N*randu<vec>(N);
		MOmega=N*randu<vec>(N);

		cout << "N=" << N << " p=" << p << endl;

		//MX.save("MX.dat",raw_ascii);
		//MX.save("MOmega.dat",raw_ascii);
		//MX.load("MX.dat",raw_ascii);
		//MOmega.load("MOmega.dat",raw_ascii);



		cout << "x_min = " << min(MX) << " x_max= " << max(MX) << endl;
		cout << "xi_min= " << min(MOmega) << " xi_max= " <<  max(MOmega) << endl;
		//cout << "MX= " <<  MX << endl;
		veccomplex fhat(N); //=randu<veccomplex>(N);
		//fhat = zeros<veccomplex>(N);
		//fhat(0)=1;
		//veccomplex fhat=ones<veccomplex>(N);


		//fhat=ones<veccomplex>(N);
		fhat= 0.5*randn<veccomplex>(N)+0.5*I*randn<veccomplex>(N);

		printf("\n");

		printf("START INIT ...\n");
		sparseFFT1D plan(&MX,&MOmega,p,N);
		sparseFFT1D_mtimes Init(&plan,&fhat);

		printf("START MTIMES ...\n");
		clock_t t_approx1=clock();
		Init.mtimes();
		clock_t t_approx2=clock();
		double sec_mtimes=double(difftime(t_approx2,t_approx1))/CLOCKS_PER_SEC;
		printf("...FINISHED (%f s)\n",sec_mtimes);
		printf("\n");

		veccomplex *f2 = new veccomplex;
		printf("START EXACT COMPUTATION ...\n");
		clock_t t_ex1=clock();
		sparseDFT1D(f2,&MX,&MOmega,&fhat,N);
		clock_t t_ex2=clock();
		double sec_ex=double(difftime(t_ex2,t_ex1))/CLOCKS_PER_SEC;
		printf("...FINISHED (%f s)\n",sec_ex);

		printf("dft - fft relative error : %.3e\n",norm(*Init.f- *f2,"inf")/norm(fhat,1));



return(1);

}
