/***
* BSFFT1D is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
* 
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program.  If not, see <http://www.gnu.org/licenses/>.
* 
* $LastChangedDate: 2016-05-20 13:54:36 +0200 (Fr, 20. Mai 2016) $
* $Author: melzer $
* $Revision: 6398 $
*
*/






/*
 * INPUT
%    N       - domain parameter, must be a power of 2
%    MX      - sampling nodes in X=[0,N]^d as M1xd matrix
%    MOmega  - sampling nodes in Omega=[0,N]^d as M2xd matrix
%
% OUTPUT
%   u  complex column vector of length size(MX,1)
 */

#include "sparseDFT1D.h"

void sparseDFT1D(veccomplex *f, vec *MX, vec *MOmega,veccomplex *fhat, unsigned int N){

unsigned int M1 = MX->n_rows;
unsigned M2 =MOmega->n_rows;

veccomplex tmpf = zeros<veccomplex>(M1);
for(unsigned int k=0;k<M1;k++){
	for(unsigned int l=0;l<M2;l++){
		dcomplex tmp= exp( 2*M_PI*I* (MX->at(k)) *(MOmega->at(l)) / (double) N )*fhat->at(l);
		tmpf.at(k) =tmpf.at(k) + tmp;
	}
}
 *f=tmpf;
}
