/***
* BSFFT1D is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
* 
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program.  If not, see <http://www.gnu.org/licenses/>.
* 
* $LastChangedDate: 2016-05-20 13:54:36 +0200 (Fr, 20. Mai 2016) $
* $Author: melzer $
* $Revision: 6398 $
*
*/






#ifndef SRC_SPARSEFFT1D_MTIMES_H_
#define SRC_SPARSEFFT1D_MTIMES_H_


#include "sparseFFT1D.h"


typedef struct cellLevelBox{
	unsigned int mA;
	unsigned int mB;
	veccomplex * u_AB;//function values
}cellLevelBox;



class sparseFFT1D_mtimes{
	friend class sparseFFT1D;
public:
	sparseFFT1D * plan;
	veccomplex * fhat; //Input
	veccomplex * f; //Output
	sparseFFT1D_mtimes(sparseFFT1D * plan_input, veccomplex *fhat_input);
	~sparseFFT1D_mtimes();

	void mtimes(void);

private:
	void getFirstFuncVal1D(veccomplex *u ,double w, double c, vector<unsigned int> *Bindex);
	void getFuncVal1DLevel(vector <cellLevelBox> * U_new, vector<cellLevelBox> * U_prev, vector< unsigned int> * AParam, vector< structLevelParaB > * BParam, unsigned int l, unsigned int numSonsLevel_l);
	void setf(veccomplex *f_input);//Set output
};


#endif /* SRC_SPARSEFFT1D_MTIMES_H_ */
