/***
* BSFFT1D is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
* 
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program.  If not, see <http://www.gnu.org/licenses/>.
* 
* $LastChangedDate: 2016-05-20 13:54:36 +0200 (Fr, 20. Mai 2016) $
* $Author: melzer $
* $Revision: 6398 $
*
*/





#ifndef TREE1D_H_
#define TREE1D_H_

#include <iostream>
#include <vector>
#include <math.h>
#include <complex>
#include <armadillo>

using namespace arma;

using namespace std;

typedef struct structLevelParaB{
	unsigned int m1B;
	unsigned int c;
}structLevelParaB;

typedef struct structLevelBox{
	unsigned int mBox; // location inside the level
	vector < unsigned int> *pind;
	unsigned int numOfSons;// number of sons
}structLevelBox; //structure for Last level


class tree1D {
	friend class sparseFFT1D;
public:
	unsigned int L;
	unsigned int l; //level l
	unsigned int m; // m - position parameter of the box
	vector<unsigned int> *pind; // indices of the nodes from the matrix [row vector]
	unsigned int numOfSons; //number of sons
	//tree1D *sons[2]; // maximal 2 sons
	vector<tree1D *> sons; //maximal 2 sons

	tree1D(); //default constructor
	tree1D(vec *M, vector<unsigned int> *pind_input, unsigned int L_input, unsigned int l_input, unsigned int m_input); //Konstruktor
	~tree1D(); //destructor

	//Methods
	bool isEmpty(void);
	void getIndicesOfTree(vector <unsigned int> * index_out);
	void getIndicesInBox(vector <unsigned int> * index_out,unsigned int l_input, unsigned int m_input);


private:
	//Methods
	void decomposeIndex1D(vector<vector<unsigned int>*> *index_output, vec *tmpM, vector<unsigned int> *index_input, unsigned int l_input, unsigned int m_input, unsigned int N_input);
	unsigned int countSonsInLevel(unsigned int l_input);
	void getLevelParaA(vector<unsigned int> *levelPara,unsigned int l_input);
	void getLevelParaB(vector<structLevelParaB> *levelParaB,unsigned int l_input);
	void getBoxes(vector<structLevelBox> *box, unsigned int l_input);
};



#endif /* TREE1D_H_ */
